%%
%% This is file `exam.cls',
%% generated with the docstrip utility.
%%
%% The original source files were:
%%
%% exam.dtx  (with options: `header,ulem,random,othercode')
%% File: exam.dtx Copyright (C) 1997-2001 Jason Alexander
%% Copyright (C) 19yy  name of author
%% 
%% This program is free software; you can redistribute it and/or
%% modify it under the terms of the GNU General Public License
%% as published by the Free Software Foundation; either version 2
%% of the License, or (at your option) any later version.
%% 
%% This program is distributed in the hope that it will be useful,
%% but WITHOUT ANY WARRANTY; without even the implied warranty of
%% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%% GNU General Public License for more details.
%% 
%% You should have received a copy of the GNU General Public License along with
%% this program; if not, write to the Free Software Foundation, Inc., 59 Temple
%% Place - Suite 330, Boston, MA  02111-1307, USA.
%% 
%% For error reports contact me at jalex@uci.edu.
%% 
\ProvidesFile{exam.dtx}
\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{exam}
\newcounter{passes}
 \setcounter{passes}{2}
\newif\ifincludeform
 \includeformtrue
\newif\ifmcbold \mcboldfalse
\newif\ifmcunder \mcunderfalse
\newif\ifulem \ulemfalse
\newif\ifbox \boxtrue
\newif\iftwocolumn \twocolumnfalse
\gdef\@OneKeyHook{\relax}
\DeclareOption{mcbold}{\mcboldtrue\boxfalse}
\DeclareOption{mcunderline}{\mcundertrue \boxfalse}
\DeclareOption{nokey}{\setcounter{passes}{1}}
\DeclareOption{onekey}{\setcounter{passes}{2}
  \gdef\@OneKeyHook{\setcounter{passes}{1}
    \gdef\@OneKeyHook{\relax}}}
\DeclareOption{noform}{\includeformfalse}
\DeclareOption{twocolumn}{\twocolumntrue}
\DeclareOption*{\PassOptionsToClass{\CurrentOption}{article}}
\ProcessOptions
\LoadClass{article}
\iftwocolumn \RequirePackage{multicol} \fi
\ifmcbold
  \ifmcunder
    \def\MCfont#1{\textbf{\uline{#1}}}
  \else
    \def\MCfont#1{\textbf{#1}}
  \fi
\else
  \ifmcunder
    \def\MCfont#1{\uline{#1}}
  \else
    \def\MCfont#1{\relax{#1}}
  \fi
\fi
\newcount\randomi % the random number seed (while executing)
\global\randomi\catcode`\@  % scratch variable during definitions
\catcode`\@=11

\def\nextrandom{\begingroup
 \ifnum\randomi<\@ne % then initialize with time
    \global\randomi\time
    \global\multiply\randomi388 \global\advance\randomi\year
    \global\multiply\randomi31 \global\advance\randomi\day
    \global\multiply\randomi97 \global\advance\randomi\month
    \message{Randomizer initialized to \the\randomi.}%
    \nextrandom \nextrandom \nextrandom
 \fi
 \count@ii\randomi
 \divide\count@ii 127773 % modulus = multiplier * 127773 + 2836
 \count@\count@ii
 \multiply\count@ii 127773
 \global\advance\randomi-\count@ii % random mod 127773
 \global\multiply\randomi 16807
 \multiply\count@ 2836
 \global\advance\randomi-\count@
 \ifnum\randomi<\z@ \global\advance\randomi 2147483647\relax\fi
 \endgroup
}

\countdef\count@ii=2 % use only in boxes!
\ifx\@tempcnta\undefined \csname newcount\endcsname \@tempcnta \fi
\ifx\@tempcntb\undefined \csname newcount\endcsname \@tempcntb \fi

\def\setrannum#1#2#3{% count register, minimum, maximum
 \@tempcnta#3\advance\@tempcnta-#2\advance\@tempcnta\@ne
 \@tempcntb 2147483645 %  =  m - 2  =  2^{31} - 3
 \divide\@tempcntb\@tempcnta
 \getr@nval
 \advance\ranval#2\relax
 #1\ranval
}

\def\setrandim#1#2#3{% dimen register, minimum length, maximum length
 \dimen@#2\dimen@ii#3\relax
 \setrannum\ranval\dimen@\dimen@ii
 #1\ranval sp\relax
}

\def\getr@nval{% The values in \@tempcnta and \@tempcntb are parameters
 \nextrandom
 \ranval\randomi \advance\ranval\m@ne \divide\ranval\@tempcntb
 \ifnum\ranval<\@tempcnta\else \expandafter\getr@nval \fi
}

\def\pointless{\expandafter\PoinTless\the}
{\catcode`p=12 \catcode`t=12
\gdef\PoinTless#1pt{#1}}

\catcode`\@=\randomi
\global\randomi=0
\newcount\ranval
\expandafter \ifx \csname UL@box\endcsname \relax \else
 \typeout{ulem.sty refuses to load twice. }\endinput \fi
\chardef\ULthickness\catcode\string`\@ % hold catcode temporarily
\catcode\string`\@=11
\def\uline{\relax \ifmmode\expandafter\underline
           \else \bgroup\expandafter\ULset\fi}
\newbox\UL@box
\newbox\UL@hyphenbox
\newskip\UL@skip
\newcount\UL@pe
\let\LA@space\ \let\LA@hskip\hskip
\def\UL@end *{\relax\relax}% something harmless unlikely to be found elsewhere
\def\ULset{\ifdim\ULdepth=\maxdimen\setbox\UL@box\hbox{(j}\ULdepth\dp\UL@box\fi
  \def\UL@leadtype{\leaders \hrule \@height\dimen@ \@depth\ULdepth}%
  \ifmmode \ULdepth-4\p@ \fi
  \dimen@-\ULdepth \advance\dimen@\ULthickness \ULon}
\def\ULon{\ifmmode \expandafter\UL@onmath\else \expandafter\UL@on\fi}
\def\UL@on#1{\leavevmode\UL@ender \let\UL@on\UL@onin
  \everymath{\UL@hrest}\everyvbox{\UL@hrest}\let\hskip\UL@hskip
  \let\\\UL@cr \let\-\UL@dischyp \let\newline\UL@newline \let\ \UL@space
  \def\hfil{\hskip\z@ plus1fil\relax}\def\hfill{\hskip\z@ plus1fill\relax}%
  \def\hss{\hskip\z@ plus1filminus1fil\relax}\let\penalty\UL@penalty
  \UL@word\@empty#1\xdef\UL@spfactor{\the\spacefactor} \UL@end * }
\def\UL@onin#1{\leavevmode\UL@ender % when nested, do multiple underlining
  \dimen@\ULthickness \advance\ULdepth\thr@@\dimen@ \advance\dimen@-\ULdepth
  \setbox\UL@box\hbox{{#1}}\let\UL@start\relax\UL@putbox\egroup}
\def\UL@onmath#1{\UL@ender\mathord{\UL@hrest\mathop{\kern\z@#1}\limits\sb
  {\UL@leadtype\LA@hskip\p@ plus1fill}}\egroup}
\def\UL@unegroup{}
\gdef\UL@ender{}
\def\UL@swender{\ifnum`{=\z@\fi\aftergroup}\gdef\UL@ender{}}
\def\UL@word#1 {\expandafter\UL@start#1 %
  \expandafter\ifx\expandafter\UL@end#1\egroup\egroup
   \unskip \unskip \unskip % remove extra leader at end
   \spacefactor\UL@spfactor \let\UL@word\egroup
  \else % not finished
   \ifmmode\else \ifdim\lastskip=\z@\else % allow syntactical spaces
     \global\UL@skip\lastskip \unskip
     \UL@stop \UL@leaders
   \fi\fi
  \fi \UL@word\@empty}% \@empty preserves braces in param
\def\UL@start{\setbox\UL@box\hbox\bgroup\everyhbox{\UL@hrest}%
  \let\UL@start\@empty \def\UL@unegroup{\bgroup\bgroup}\let\UL@leadtype\@empty
  \bgroup \kern-3sp\kern3sp % kerns so I can test for beginning of list
  \if@ignore \global\@ignorefalse \ignorespaces \fi}
\def\UL@stop{\global\UL@pe\lastpenalty \unpenalty % penalty in \UL@pe
  \ifnum\lastkern=\thr@@ \egroup\egroup % Nothing in hbox...but make sure:
    \ifdim\wd\UL@box=\z@ \else \UL@putbox \fi % something in box so print it
  \else  \egroup\egroup \UL@putbox % something in box so print it
  \fi \ifnum\UL@pe=\z@ \else \LA@penalty\UL@pe \fi % use penalty from inside box
  \UL@unegroup}
\def\UL@putbox{\ifx\UL@start\@empty \else % not inner
  \vrule\@width\z@ \LA@penalty\@M
  {\UL@skip\wd\UL@box \UL@leaders \kern-\UL@skip}%
  \box\UL@box  \fi}
\newdimen\UL@pixel \UL@pixel=1in \divide\UL@pixel 300
\def\UL@leaders{{\LA@hskip-\UL@pixel \advance\UL@skip\tw@\UL@pixel
   \UL@leadtype\LA@hskip\UL@skip  \LA@hskip-\UL@pixel}}
\def\UL@hrest{\let\ \LA@space \let\-\@empty \let\penalty\LA@penalty}
\def\UL@space{\LA@space \global\UL@skip\lastskip \unskip \UL@reskip}% \
\def\UL@dischyp{\global\setbox\UL@hyphenbox\hbox
   {\ifnum \hyphenchar\font<\z@ \string-\else \char\hyphenchar\font \fi}%
   \kern\wd\UL@hyphenbox \LA@penalty\@M \UL@stop \kern-\wd\UL@hyphenbox
   \discretionary{\box\UL@hyphenbox}{}{}\UL@start}
\let\LA@penalty\penalty
\def\UL@penalty{\relax\ifhmode \afterassignment\UL@@penalty\count@
  \else\LA@penalty\fi}
\def\UL@@penalty{\LA@penalty \ifnum\count@=\z@
  \@ne \else \count@ \fi % zero penalty => no penalty, so use 1 instead.
  \UL@stop \UL@start}
\def\UL@hskip{\ifx\ \LA@space \LA@hskip \else
  \afterassignment\UL@reskip \global\UL@skip \fi}
\def\UL@reskip{\UL@stop \UL@leaders \UL@start}
\def\UL@cr{\unskip \ifx\ \LA@space \let\UL@vad\@gobble
  \else \UL@stop \unskip\unskip\unskip \let\UL@vad\vadjust \fi
  \@ifstar{\UL@vad{\LA@penalty\@M}\UL@cra}\UL@cra}
\def\UL@cra{\@ifnextchar[\UL@crb\UL@newline}
\def\UL@crb[#1]{\UL@vad{\vskip#1}\UL@newline}
\def\UL@newline{\ifx\UL@start\@empty % (\UL@cr may have \UL@stop-ed already)
  \unskip \ifx\ \LA@space \else \UL@stop \unskip\unskip\unskip \fi\fi
  \LA@hskip \z@\@plus.0001fil\LA@penalty -\@M \UL@start}
\newbox\ULC@box
\def\markoverwith#1{\setbox\ULC@box\hbox{{#1}}\UL@pixel.5\wd\ULC@box
   \ifmmode \setbox\ULC@box\hbox{\raise1.4ex\box\ULC@box}%
    \dp\ULC@box-1.4ex\ht\ULC@box\z@ \def\UL@leadtype{\cleaders\copy\ULC@box}%
   \else
    \def\UL@leadtype{\leaders\copy\ULC@box}%
   \fi}
\def\uwave{\bgroup \markoverwith{\lower3.5\p@\hbox{\sixly
  \kern-.21\p@ \char58 \kern-.21\p@}}\ULon}
\font\sixly=lasy6 % does not re-load if already loaded, so no memory problem.
\def\uuline{\bgroup \markoverwith{\hbox
 {\kern-.03em\vtop{\kern.2ex\hrule width.2em\kern1.1\p@
 \hrule}\kern-.03em}}\ULon}
\def\sout{\bgroup \ULdepth=-.5ex \ULset}
\def\xout{\bgroup \markoverwith{\kern-.1em{/}\kern-.1em}\ULon}
\def\useunder#1#2#3{\relax
  \ifx\relax#2\relax\else % declaration command given
    \def#2{\def\@tempa{#1}\global\let\UL@ender\UL@swender
    \expandafter\@tempa\expandafter{\ifnum\z@=\string`}\fi}%
    \MakeRobust{#2}\fi
  \ifx\relax#3\relax\else % argumentative command
    \def#3{#1}\MakeRobust{#3}\fi}
\expandafter\ifx \csname @ifundefined\endcsname \relax
  \def\@height{height}
  \def\@depth{depth}
  \def\@width{width}
  \def\@empty{}
  \def\@gobble#1{}
  \def\MakeRobust#1{}
  \csname newif\expandafter\endcsname \csname if@ignore\endcsname
\else
 \def\MakeRobust#1{\expandafter\let
   \csname \expandafter\@gobble\string#1 \endcsname= #1%
  \edef#1{\noexpand\protect \expandafter\noexpand
   \csname\expandafter\@gobble\string#1 \endcsname}
  }
  \MakeRobust\uline
  \MakeRobust\uuline
  \MakeRobust\uwave
  \MakeRobust\sout
  \MakeRobust\xout
  \let\LA@em\em   \let\LA@emph\emph
  \expandafter\let\expandafter\LA@Pem \csname em \endcsname
  \expandafter\let\expandafter\LA@Pemph \csname emph \endcsname
  \def\ULforem{\useunder{\uline}{\em}{\emph}}
  \def\normalem{\let\em\LA@em \let\emph\LA@emph
    \expandafter\let\csname em \endcsname\LA@Pem
    \expandafter\let\csname emph \endcsname\LA@Pemph}
  \ULforem  %  default is to use underlining for \em,
\fi
\catcode`@=\ULthickness % Scratch meaning: restore catcode of @
\def\ULthickness{.4pt}% can change this with \renewcommand
\newdimen\ULdepth  \ULdepth=\maxdimen

\normalem
\setcounter{section}{0}
\newcounter{extract}
\newcounter{question} \setcounter{question}{1}
\newcounter{length} \setcounter{length}{0}
\newcounter{temp} \setcounter{temp}{1}
\newcounter{wordtemp} \setcounter{wordtemp}{1}
\newcounter{form}
\newcounter{version}
\newcounter{current@section}
\newcounter{current@question}
\newcounter{innerloop}
\newcounter{sect}
\newcounter{sectionindex}
\newcounter{answer}
\newcounter{choice}
 \setcounter{choice}{1}
\newcounter{mcquestion} \setcounter{mcquestion}{1}
\newcounter{mcchoice} \setcounter{mcchoice}{1}
\newcounter{savelistcnt}
\newlength{\blank@length}
\newlength{\temp@length}
\newlength{\temp@@length}
\newlength{\namedata@vspace}
\newlength{\beforesectsep}
 \setlength{\beforesectsep}{\medskipamount}
\newlength{\aftersectsep}
 \setlength{\aftersectsep}{\medskipamount}
\newlength{\beforeinstsep}
 \setlength{\beforeinstsep}{\medskipamount}
\newlength{\afterinstsep}
 \setlength{\afterinstsep}{\medskipamount}
 \addtolength{\afterinstsep}{-\topsep}
\newif\ifchoice \choicefalse
\newif\ifanswer
\newif\ifnotfixed
\newif\ifcblanks \cblanksfalse
\newif\ifpblanks \pblankstrue
\newif\ifidentifier \identifierfalse
\newif\ifFirstQuestionInBlock \FirstQuestionInBlocktrue
\global\newtoks\temptoks
\global\newtoks\temp@toks
\newcount\exam@c
\newcount\exam@n
\newcount\exam@m
\setrannum{\exam@m}{1}{10}
\newtoks\@toklist
\def\section{\stepcounter{section}
  \setcounter{question}{1}}
\long\def\get@instructions#1\begin{\@toklist=\expandafter{\the\@toklist#1}%
  \find@instructions@end}
\def\find@instructions@end#1{%
  \def\@tempa{#1}%
  \ifx\@tempa\@Q
    \let\@next=\Qwrap@up@instructions
  \else
    \ifx\@tempa\@Block
      \let\@next=\Bwrap@up@instructions
    \else
      \@toklist=\expandafter{\the\@toklist\begin{#1}}%
      \let\@next=\get@instructions
   \fi\fi\@next}
\def\Qwrap@up@instructions{%
 \edef\@@temp{\roman{section}}
 \expandafter\xdef\csname inst@sec\@@temp\endcsname{\the\@toklist}
 \begin{question}}
\def\Bwrap@up@instructions{%
 \edef\@@temp{\roman{section}}
 \expandafter\xdef\csname inst@sec\@@temp\endcsname{\the\@toklist}
 \begin{block}}
\def\endsection{\make@qlist}
\def\make@qlist{%
  \setcounter{temp}{1}
  \edef\@tempa{\roman{section}}%
  \global\expandafter\newtoks\csname qlist@sec\@tempa\endcsname
  \global\expandafter\newtoks\csname qlist@scr@sec\@tempa\endcsname
  \global\csname qlist@scr@sec\@tempa\endcsname={}
  \@whilenum \value{question}>1 \do{%
    \edef\@questionnumber{\arabic{temp}}%
    \expandafter\append\expandafter{\@questionnumber}%
       {\csname qlist@sec\@tempa\endcsname}
    \addtocounter{question}{-1}
    \addtocounter{temp}{1}}}
\def\question{\@toklist={}
 \get@question@body}
\def\endquestion{\stepcounter{question}}
\long\def\get@question@body#1\end{\@toklist=\expandafter{\the\@toklist#1}%
  \find@question@end}
\def\find@question@end#1{%
  \def\@tempa{#1}%
   \ifx\@tempa\@Q\expandafter\wrap@up
    \else\@toklist=\expandafter{\the\@toklist\end{#1}}%
     \expandafter\get@question@body\fi}
\def\wrap@up{%
 \edef\@tempa{\roman{section}}%
 \edef\@tempb{\roman{question}}%
 \ifx\@currentsectionname\@truefalse
   \expandafter\xdef\csname sec\@tempa @qst\@tempb\endcsname{%
     \noexpand\@tfitem
     \noexpand\@beforequestionhook
     \the\@toklist
     \noexpand\@endquestionhook}
   \else
   \ifx\@currentsectionname\@truefalsestar
     \expandafter\xdef\csname sec\@tempa @qst\@tempb\endcsname{%
       \noexpand\@tfitem
       \noexpand\@beforequestionhook
       \the\@toklist
       \noexpand\@endquestionhook}
     \else
     \ifx\@currentsectionname\@MC
       \expandafter\xdef\csname sec\@tempa @qst\@tempb\endcsname{%
         \noexpand\@mcitem
         \noexpand\begin{minipage}[t]{\noexpand\linewidth}
         \noexpand\@beforequestionhook
         \the\@toklist
         \noexpand\@mcenditem
         \noexpand\end{minipage}
         \noexpand\@endquestionhook}
       \else
       \ifx\@currentsectionname\@MCstar
         \expandafter\xdef\csname sec\@tempa @qst\@tempb\endcsname{%
           \noexpand\@mcitem
           \noexpand\begin{minipage}[t]{\noexpand\linewidth}
           \noexpand\@beforequestionhook
           \the\@toklist
           \noexpand\@mcenditem
           \noexpand\end{minipage}
           \noexpand\@endquestionhook}
       \else
       \expandafter\xdef\csname sec\@tempa @qst\@tempb\endcsname{%
         \noexpand\item
         \noexpand\@beforequestionhook
         \the\@toklist
         \noexpand\@endquestionhook}
   \fi\fi\fi\fi
   \end{question}}
\def\@Q{question}
\def\block{\@toklist={}
 \get@block@body}
\long\def\get@block@body#1\end{\@toklist=\expandafter{\the\@toklist #1}%
  \find@block@end}
\def\find@block@end#1{%
  \def\@tempa{#1}%
   \ifx\@tempa\@Block\expandafter\block@wrap@up
    \else\@toklist=\expandafter{\the\@toklist\end{#1}}%
     \expandafter\get@block@body\fi}
\def\block@wrap@up{%
 \edef\@tempa{\roman{section}}%
 \edef\@tempb{\roman{question}}%
 \expandafter\xdef\csname sec\@tempa @qst\@tempb\endcsname{%
   \noexpand\@startofblockhook
   \noexpand\@blockbreaklist
   \the\@toklist
   \noexpand\@endofblockhook}%
 \end{block}}
\def\@startofblockhook{\relax}
\def\@blockbreaklist{\@testforquestion}
\def\@testforquestion#1#2{%
  \def\@@@temp{#2}
  \ifx#1\begin
    \ifx\@@@temp\@Q
      \relax
    \else
      \item[]
    \fi
  \else
    \item[]
  \fi #1{#2}}
\def\@endofblockhook{\relax}
\def\@Block{block}
\def\endblock{\stepcounter{question}}
\def\frontmatter{\@toklist={}
 \get@frontmatter@body}
\def\endfrontmatter{\relax}
\long\def\get@frontmatter@body#1\end{%
  \@toklist=\expandafter{\the\@toklist#1}%
  \find@frontmatter@end}
\def\find@frontmatter@end#1{%
  \def\@tempa{#1}%
  \ifx\@tempa\@Frontmatter
    \expandafter\frontmatter@wrap@up
  \else
    \@toklist=\expandafter{\the\@toklist\end{#1}}%
    \expandafter\get@frontmatter@body
  \fi}
\def\frontmatter@wrap@up{%
  \xdef\@frontmattertext{\the\@toklist}
  \end{frontmatter}}
\def\@Frontmatter{frontmatter}
\def\endmatter{\@toklist={}
 \get@endmatter@body}
\def\endendmatter{\relax}
\long\def\get@endmatter@body#1\end{%
  \@toklist=\expandafter{\the\@toklist#1}%
  \find@endmatter@end}
\def\find@endmatter@end#1{%
  \def\@tempa{#1}%
  \ifx\@tempa\@Endmatter
    \expandafter\endmatter@wrap@up
  \else
    \@toklist=\expandafter{\the\@toklist\end{#1}}%
    \expandafter\get@endmatter@body
  \fi}
\def\endmatter@wrap@up{%
  \xdef\@endmattertext{\the\@toklist}
  \end{endmatter}}
\def\@Endmatter{endmatter}
\begin{frontmatter}
  \relax
\end{frontmatter}
\begin{endmatter}
  \relax
\end{endmatter}
\def\exampreface{\@toklist={}
 \get@exampreface@body}
\def\endexampreface{\relax}
\long\def\get@exampreface@body#1\end{%
  \@toklist=\expandafter{\the\@toklist#1}%
  \find@exampreface@end}
\def\find@exampreface@end#1{%
  \def\@tempa{#1}%
  \ifx\@tempa\@Exampreface
    \expandafter\exampreface@wrap@up
  \else
    \@toklist=\expandafter{\the\@toklist\end{#1}}%
    \expandafter\get@exampreface@body
  \fi}
\def\exampreface@wrap@up{%
  \xdef\@examprefacetext{\the\@toklist}
  \end{exampreface}}
\def\@Exampreface{exampreface}
\def\examclosing{\@toklist={}
 \get@examclosing@body}
\def\endexamclosing{\relax}
\long\def\get@examclosing@body#1\end{%
  \@toklist=\expandafter{\the\@toklist#1}%
  \find@examclosing@end}
\def\find@examclosing@end#1{%
  \def\@tempa{#1}%
  \ifx\@tempa\@Examclosing
    \expandafter\examclosing@wrap@up
  \else
    \@toklist=\expandafter{\the\@toklist\end{#1}}%
    \expandafter\get@examclosing@body
  \fi}
\def\examclosing@wrap@up{%
  \xdef\@examclosingtext{\the\@toklist}
  \end{examclosing}}
\def\@Examclosing{examclosing}
\begin{exampreface}
  \relax
\end{exampreface}
\begin{examclosing}
  \relax
\end{examclosing}
\def\keypreface{\@toklist={}
 \get@keypreface@body}
\def\endkeypreface{\relax}
\long\def\get@keypreface@body#1\end{%
  \@toklist=\expandafter{\the\@toklist#1}%
  \find@keypreface@end}
\def\find@keypreface@end#1{%
  \def\@tempa{#1}%
  \ifx\@tempa\@Keypreface
    \expandafter\keypreface@wrap@up
  \else
    \@toklist=\expandafter{\the\@toklist\end{#1}}%
    \expandafter\get@keypreface@body
  \fi}
\def\keypreface@wrap@up{%
  \xdef\@keyprefacetext{\the\@toklist}
  \end{keypreface}}
\def\@Keypreface{keypreface}
\def\keyclosing{\@toklist={}
 \get@keyclosing@body}
\def\endkeyclosing{\relax}
\long\def\get@keyclosing@body#1\end{%
  \@toklist=\expandafter{\the\@toklist#1}%
  \find@keyclosing@end}
\def\find@keyclosing@end#1{%
  \def\@tempa{#1}%
  \ifx\@tempa\@Keyclosing
    \expandafter\keyclosing@wrap@up
  \else
    \@toklist=\expandafter{\the\@toklist\end{#1}}%
    \expandafter\get@keyclosing@body
  \fi}
\def\keyclosing@wrap@up{%
  \xdef\@keyclosingtext{\the\@toklist}
  \end{keyclosing}}
\def\@Keyclosing{keyclosing}
\begin{keypreface}
  \relax
\end{keypreface}
\begin{keyclosing}
  \relax
\end{keyclosing}
\def\append#1#2{%
  \global\temp@toks=\expandafter{\the #2\@separator {#1}}%
  \global#2=\expandafter{\the\temp@toks}}
\def\length#1{%
  \setcounter{length}{0}
  \def\@separator##1{\stepcounter{length}}\the#1}
\def\remove#1#2{%
  \exam@c=0
  \temptoks={}
  \def\@separator##1{\advance\exam@c by 1\relax
     \ifnum\exam@c=#1\relax%
     \setcounter{extract}{##1}%
     \else\append{##1}{\temptoks}
     \fi}
  \the#2
  \global#2=\expandafter{\the\temptoks}}
\let\@oldenddocumenthook=\@enddocumenthook
\def\@enddocumenthook{%
  \gdef\question{\item \@beforequestionhook}
  \gdef\endquestion{\@endquestionhook}
  \setcounter{version}{1}
  \stepcounter{form}
  \@whilenum \value{version}<\value{form} \do{%
    \setcounter{innerloop}{0}
    \@whilenum \value{innerloop}<\value{passes} \do{%
        \setcounter{page}{1}
        \ifx\@frontmattertext\relax
          \relax
        \else
          \@frontmattertext \pagebreak
        \fi
        \ifnum \value{innerloop}=0 %
          \@examtopmatter
          \answerfalse
          \iftwocolumn \begin{multicols}{2}\fi
          \@examprefacetext
        \else%
          \@keytopmatter
          \answertrue
          \iftwocolumn \begin{multicols}{2}\fi
          \@keyprefacetext
        \fi
        \setcounter{sectionindex}{0}
        \@whilenum \value{sectionindex}<\value{section} \do{%
            \addtocounter{sectionindex}{1}
            \edef\current@section{\roman{sectionindex}}
            \length{\csname qlist@sec\current@section\endcsname}
            \csname sec\current@section @fixed\endcsname
            \ifnotfixed
            \ifanswer\relax\else
            \typeout{Scrambling section \current@section, question: }\fi
            \@whilenum \value{length}>0 \do{%
              \setrannum{\exam@m}{1}{\value{length}}
              \remove{\exam@m}{\csname qlist@sec\current@section\endcsname}
              \edef\@TEMP{\theextract}
              \ifnum \value{length}=1
               \message{\@TEMP.}
                \else \message{\@TEMP,}\fi
              \expandafter\append\expandafter{\@TEMP}{\csname
                qlist@scr@sec\current@section\endcsname}
              \length{\csname qlist@sec\current@section\endcsname}}
            \else
              \csname qlist@scr@sec\current@section\endcsname=\expandafter{%
               \the\csname qlist@sec\current@section\endcsname}
            \fi
        \expandafter\ifx\csname type@sec\current@section\endcsname\@shortanswer
            \def\@separator##1{\setcounter{temp}{##1}
              \edef\current@question{\roman{temp}}
              \csname sec\current@section @qst\current@question\endcsname}
          \ifanswer
            \gdef\answer{\begin{description} \item[Answer:]}
            \gdef\endanswer{\end{description}}
          \else
            \def\answer{\get@noanswer@body}
            \def\endanswer{\relax}
            \def\@S{answer}
            \long\def\get@noanswer@body##1\end{\find@answer@end}
            \def\find@answer@end##1{\def\@tempa{##1}
              \ifx\@tempa\@S\expandafter\finish@up
                \else\expandafter\get@noanswer@body\fi}
            \def\finish@up{\end{answer}}
          \fi
          \par\vspace{\beforesectsep}
          \noindent {\large Section \arabic{sectionindex}. \space
           \csname head@sec\current@section\endcsname}
           \par\vspace{\aftersectsep}
          \ifx\csname inst@sec\current@section\endcsname\relax
            \relax
          \else
            \vspace{\beforeinstsep}
            \csname inst@sec\current@section\endcsname
            \par\vspace{\afterinstsep}
          \fi
          \begin{enumerate}
             \the\csname qlist@scr@sec\current@section\endcsname
          \end{enumerate}
        \fi
        \expandafter\ifx\csname type@sec\current@section\endcsname\@fixed
            \def\@separator##1{\setcounter{temp}{##1}
              \edef\current@question{\roman{temp}}
              \csname sec\current@section @qst\current@question\endcsname}
          \ifanswer
            \gdef\answer{\begin{description} \item[Answer:]}
            \gdef\endanswer{\end{description}}
          \else
            \def\answer{\get@noanswer@body}
            \def\endanswer{\relax}
            \def\@S{answer}
            \long\def\get@noanswer@body##1\end{\find@answer@end}
            \def\find@answer@end##1{\def\@tempa{##1}
              \ifx\@tempa\@S\expandafter\finish@up
                \else\expandafter\get@noanswer@body\fi}
            \def\finish@up{\end{answer}}
          \fi
          \par\vspace{\beforesectsep}
          \noindent {\large Section \arabic{sectionindex}. \space
           \csname head@sec\current@section\endcsname}
           \par\vspace{\aftersectsep}
          \ifx\csname inst@sec\current@section\endcsname\relax
            \relax
          \else
            \vspace{\beforeinstsep}
            \csname inst@sec\current@section\endcsname
            \par\vspace{\afterinstsep}
          \fi
          \begin{enumerate}
             \the\csname qlist@scr@sec\current@section\endcsname
          \end{enumerate}
          \global\notfixedtrue
        \fi
        \expandafter\ifx\csname type@sec\current@section\endcsname\@fillin
          \def\@separator##1{\setcounter{temp}{##1}
            \edef\current@question{\roman{temp}}
            \csname sec\current@section @qst\current@question\endcsname}
          \ifanswer
            \ifcblanks
              \def\blank##1{\mbox{\rule[-1pt]{\blank@length}{.4pt}%
                \hspace{-\blank@length}%
                \makebox[\blank@length]{##1}}}
            \fi
            \ifpblanks
              \def\blank##1{\settowidth{\temp@length}{##1}%
                \mbox{\rule[-1pt]{\blank@multiplier\temp@length}{.4pt}%
                \hspace{-\blank@multiplier\temp@length}%
                \makebox[\blank@multiplier\temp@length]{##1}}}
            \fi
            \else
             \ifcblanks
              \def\blank##1{\rule[-1pt]{\blank@length}{.4pt}}
             \fi
             \ifpblanks
              \def\blank##1{\settowidth{\temp@length}{##1}%
                \rule[-1pt]{\blank@multiplier\temp@length}{.4pt}}
             \fi
          \fi
          \par\vspace{\beforesectsep}
          \noindent {\large Section \arabic{sectionindex}. \space
           \csname head@sec\current@section\endcsname}
           \par\vspace{\aftersectsep}
          \ifx\csname inst@sec\current@section\endcsname\relax
            \relax
          \else
            \vspace{\beforeinstsep}
            \csname inst@sec\current@section\endcsname
            \par\vspace{\afterinstsep}
          \fi
          \begin{enumerate}
            \the\csname qlist@scr@sec\current@section\endcsname
          \end{enumerate}
        \fi
          \expandafter\ifx\csname type@sec\current@section\endcsname\@fillinstar
            \@fillinstarmain
          \fi
          \expandafter\ifx\csname type@sec\current@section\endcsname\@MC
            \@multiplechoicemain
          \fi
          \expandafter\ifx\csname type@sec\current@section\endcsname\@MCstar
            \@multiplechoicestarmain
          \fi
          \expandafter\ifx\csname type@sec\current@section\endcsname\@shortanswerstar
            \@shortanswerstarmain
          \fi
          \expandafter\ifx\csname type@sec\current@section\endcsname\@truefalse
            \@truefalsemain
          \fi
          \expandafter\ifx\csname type@sec\current@section\endcsname\@truefalsestar
            \@truefalsestarmain
          \fi
          \expandafter\ifx\csname type@sec\current@section\endcsname\@fixedstar
            \@fixedstarmain
          \fi
          }
        \ifnum \value{innerloop}=0 %
          \@examclosingtext\par
        \else
          \@keyclosingtext\par
        \fi
        \iftwocolumn \end{multicols} \fi
        \ifx\@endmattertext\relax
          \relax
        \else
          \pagebreak \@endmattertext \par
        \fi
        \pagebreak
        \addtocounter{innerloop}{1}}
      \@OneKeyHook
      \stepcounter{version}
      \setcounter{sectionindex}{0}
      \@whilenum \value{sectionindex}<\value{section} \do{%
        \addtocounter{sectionindex}{1}
        \edef\current@section{\roman{sectionindex}}
        \csname sec\current@section @fixed\endcsname
        \ifnotfixed
        \csname qlist@sec\current@section\endcsname=\expandafter{\the\csname
          qlist@scr@sec\current@section\endcsname}
        \csname qlist@scr@sec\current@section\endcsname={}
        \else \notfixedtrue\fi}
      }}
\def\NumberOfVersions#1{\setcounter{form}{#1}}
 \NumberOfVersions{1}
\def\instructions{\relax}
\def\class#1{\def\classdata{#1}}
\def\classdata{\relax}
\def\examname#1{\def\examtype{#1}}
 \examname{Exam}
\def\namedata{Name: \hrulefill \\[\namedata@vspace]
              Student Number: \hrulefill \\[\namedata@vspace]
              TA: \hrulefill \\[\namedata@vspace]
              Date: \hrulefill}
\newenvironment{fillin}[1][:]
  {\begin{section}
   \def\@currentsectionname{fillin}
   \edef\@@temp{\roman{section}}
   \expandafter\gdef\csname type@sec\@@temp\endcsname{fillin}
   \expandafter\gdef\csname sec\@@temp @fixed\endcsname{\notfixedtrue}
   \ifx#1:
     \expandafter\gdef\csname head@sec\@@temp\endcsname{\relax}
   \else
     \expandafter\gdef\csname head@sec\@@temp\endcsname{#1}
   \fi
   \get@instructions \relax}
  {\end{section}}
\newenvironment{fillin*}[1][:]
  {\begin{section}
   \def\@currentsectionname{fillin*}
   \edef\@@temp{\roman{section}}
   \expandafter\gdef\csname type@sec\@@temp\endcsname{fillin*}
   \expandafter\gdef\csname sec\@@temp @fixed\endcsname{\notfixedtrue}
   \ifx#1:
     \expandafter\gdef\csname head@sec\@@temp\endcsname{\relax}
   \else
     \expandafter\gdef\csname head@sec\@@temp\endcsname{#1}
   \fi
   \get@instructions \relax}
  {\end{section}}
\newenvironment{truefalse}[1][:]
  {\begin{section}
   \def\@currentsectionname{truefalse}
   \edef\@@temp{\roman{section}}
   \expandafter\gdef\csname type@sec\@@temp\endcsname{truefalse}
   \expandafter\gdef\csname sec\@@temp @fixed\endcsname{\notfixedtrue}
   \ifx#1:
     \expandafter\gdef\csname head@sec\@@temp\endcsname{\relax}
   \else
     \expandafter\gdef\csname head@sec\@@temp\endcsname{#1}
   \fi
   \get@instructions \relax}
  {\end{section}}
\newenvironment{truefalse*}[1][:]
  {\begin{section}
   \def\@currentsectionname{truefalse*}
   \edef\@@temp{\roman{section}}
   \expandafter\gdef\csname type@sec\@@temp\endcsname{truefalse*}
   \expandafter\gdef\csname sec\@@temp @fixed\endcsname{\notfixedtrue}
   \ifx#1:
     \expandafter\gdef\csname head@sec\@@temp\endcsname{\relax}
   \else
     \expandafter\gdef\csname head@sec\@@temp\endcsname{#1}
   \fi
   \get@instructions \relax}
  {\end{section}}
\newenvironment{shortanswer}[1][:]
  {\begin{section}
   \def\@currentsectionname{shortanswer}
   \edef\@@temp{\roman{section}}
   \expandafter\gdef\csname type@sec\@@temp\endcsname{shortanswer}
   \expandafter\gdef\csname sec\@@temp @fixed\endcsname{\notfixedtrue}
   \ifx#1:
     \expandafter\gdef\csname head@sec\@@temp\endcsname{\relax}
   \else
     \expandafter\gdef\csname head@sec\@@temp\endcsname{#1}
   \fi
   \get@instructions \relax}
  {\end{section}}
\newenvironment{shortanswer*}[1][:]
  {\begin{section}
   \def\@currentsectionname{shortanswer*}
   \edef\@@temp{\roman{section}}
   \expandafter\gdef\csname type@sec\@@temp\endcsname{shortanswer*}
   \expandafter\gdef\csname sec\@@temp @fixed\endcsname{\notfixedtrue}
   \ifx#1:
     \expandafter\gdef\csname head@sec\@@temp\endcsname{\relax}
   \else
     \expandafter\gdef\csname head@sec\@@temp\endcsname{#1}
   \fi
   \get@instructions \relax}
  {\end{section}}
\newenvironment{multiplechoice}[1][:]
  {\begin{section}
   \def\@currentsectionname{multiplechoice}
   \edef\@@temp{\roman{section}}
   \expandafter\gdef\csname type@sec\@@temp\endcsname{multiplechoice}
   \expandafter\gdef\csname sec\@@temp @fixed\endcsname{\notfixedtrue}
   \ifx#1:
     \expandafter\gdef\csname head@sec\@@temp\endcsname{\relax}
   \else
     \expandafter\gdef\csname head@sec\@@temp\endcsname{#1}
   \fi
   \get@instructions \relax}
  {\end{section}}
\newenvironment{multiplechoice*}[1][:]
  {\begin{section}
   \def\@currentsectionname{multiplechoice*}
   \edef\@@temp{\roman{section}}
   \expandafter\gdef\csname type@sec\@@temp\endcsname{multiplechoice*}
   \expandafter\gdef\csname sec\@@temp @fixed\endcsname{\notfixedtrue}
   \ifx#1:
     \expandafter\gdef\csname head@sec\@@temp\endcsname{\relax}
   \else
     \expandafter\gdef\csname head@sec\@@temp\endcsname{#1}
   \fi
   \get@instructions \relax}
  {\end{section}}
\newenvironment{fixed}[1][:]
  {\begin{section}
   \def\@currentsectionname{fixed}
   \edef\@@temp{\roman{section}}
   \expandafter\gdef\csname type@sec\@@temp\endcsname{fixed}
   \expandafter\gdef\csname sec\@@temp @fixed\endcsname{\notfixedfalse}
   \ifx#1:
     \expandafter\gdef\csname head@sec\@@temp\endcsname{\relax}
   \else
     \expandafter\gdef\csname head@sec\@@temp\endcsname{#1}
   \fi
   \get@instructions \relax}
  {\end{section}}
\newenvironment{fixed*}[1][:]
  {\begin{section}
   \def\@currentsectionname{fixed*}
   \edef\@@temp{\roman{section}}
   \expandafter\gdef\csname type@sec\@@temp\endcsname{fixed*}
   \expandafter\gdef\csname sec\@@temp @fixed\endcsname{\notfixedfalse}
   \ifx#1:
     \expandafter\gdef\csname head@sec\@@temp\endcsname{\relax}
   \else
     \expandafter\gdef\csname head@sec\@@temp\endcsname{#1}
   \fi
   \get@instructions \relax}
  {\end{section}}
\def\@fillin{fillin}
\def\@fillinstar{fillin*}
\def\@shortanswer{shortanswer}
\def\@shortanswerstar{shortanswer*}
\def\@truefalse{truefalse}
\def\@truefalsestar{truefalse*}
\def\@MC{multiplechoice}
\def\@MCstar{multiplechoice*}
\def\@fixed{fixed}
\def\@fixedstar{fixed*}
\newcommand{\choice}[3][]{%
  \ifchoice \relax
    \else \@mcstartlist \choicetrue
  \fi
  \ifanswer
    \if#1!%
      \ifbox \vspace{-\fboxsep}\item[\hfill\fbox{(\alph{choice})}\hfill] #2
        \vspace{-\fboxsep}%
      \else
         \item[\hfill\MCfont{(\alph{choice})}\hfill] \MCfont{#2}
      \fi
    \else \item[\hfill(\alph{choice})\hfill] #2
    \fi \stepcounter{choice}
  \else
% MW:
%    \item[\hfill(\alph{choice})\hfill] #2
    \item[\choicelabel] #2
% :MW
    \stepcounter{choice}
  \fi
  \ifx#3\choice \relax
  \else \end{list}
     \setcounter{choice}{1}
     \choicefalse
  \fi #3}
% MW:
\newcommand*\choicelabel{\hfill(\alph{choice})\hfill}
% :MW
\def\@mcstartlist{\begin{list}{}{%
 \setlength{\topsep}{6pt}
 \setlength{\rightmargin}{0pt}
 \setlength{\labelwidth}{.35in}
 \setlength{\leftmargin}{.5in}
 \setlength{\labelsep}{.15in}
 \setlength{\itemindent}{0in}
 \setlength{\itemsep}{0pt}}}
\newcommand{\Fullpages}{\setlength{\topmargin}{0pc}
                        \setlength{\oddsidemargin}{0pc}
                        \setlength{\evensidemargin}{0pc}
                        \setlength{\headheight}{0pc}
                        \setlength{\headsep}{0pc}
                        \setlength{\textwidth}{6.5in}
                        \setlength{\textheight}{9in}}
\def\ConstantBlanks#1{\setlength{\blank@length}{#1}\cblankstrue\pblanksfalse}
\def\ProportionalBlanks#1{\edef\blank@multiplier{#1}\cblanksfalse\pblankstrue}
 \ProportionalBlanks{1}
\newcommand{\StudentInfoLineSpacing}[1]{\setlength{\namedata@vspace}{#1}}
 \StudentInfoLineSpacing{6pt}
\def\examtop{\@toklist={}
 \get@examtop@body}
\def\endexamtop{\relax}
\long\def\get@examtop@body#1\end{%
  \@toklist=\expandafter{\the\@toklist#1}%
  \find@examtop@end}
\def\find@examtop@end#1{%
  \def\@tempa{#1}%
   \ifx\@tempa\@XMtop\expandafter\XMtop@wrap@up
    \else\@toklist=\expandafter{\the\@toklist\end{#1}}%
     \expandafter\get@examtop@body\fi}
\def\XMtop@wrap@up{\xdef\@examtopmatter{\the\@toklist}%
 \end{examtop}}
\def\@XMtop{examtop}
\begin{examtop}
\@@line{\parbox{3in}{\classdata \\
        \examtype\ifincludeform, Form:
        \fbox{\textsf{\Alph{version}}}\fi}
        \hfill
        \parbox{3in}{\normalsize \namedata}}
        \bigskip
\end{examtop}
\def\keytop{\@toklist={}
 \get@keytop@body}
\def\endkeytop{\relax}
\long\def\get@keytop@body#1\end{\@toklist=\expandafter{\the\@toklist#1}%
  \find@keytop@end}
\def\find@keytop@end#1{%
  \def\@tempa{#1}%
   \ifx\@tempa\@KYtop\expandafter\KYtop@wrap@up
    \else\@toklist=\expandafter{\the\@toklist\end{#1}}%
     \expandafter\get@keytop@body\fi}
\def\KYtop@wrap@up{\xdef\@keytopmatter{\the\@toklist}%
 \end{keytop}}
\def\@KYtop{keytop}
\begin{keytop}
\@@line{\hfill \Huge Answer Key
        \ifincludeform for Exam \fbox{\textsf{\Alph{version}}}
        \fi \hfill}
        \bigskip
\end{keytop}
\def\@Space{ }
\def\word#1{\def\@wordlist{#1}\expandafter\@wordmain\@wordlist \stop}

\def\@wordmain#1{%
  \ifx#1\@Space
   \let\@next=\@wordmain
  \else
   \ifx#1\stop
    \let\@next=\@dumpthenstart
   \else%
    \ifnum\value{wordtemp}=\value{version}%
     #1\let\@next=\@gobbletostop
    \else
     \stepcounter{wordtemp}%
     \let\@next=\@wordmain
    \fi
   \fi
  \fi
  \@next}
\def\@dumpthenstart{\expandafter\@wordmain\@wordlist \stop}
\def\@gobbletostop#1\stop{\relax\setcounter{wordtemp}{1}}
\def\ifsection#1#2{\def\@temp{#1}
 \expandafter\ifx\csname type@sec\current@section\endcsname\@temp #2 \fi}
\def\@fillinstarmain{%
  \def\question{\item \@beforequestionhook}
  \def\endquestion{\@endquestionhook}
  \def\@separator##1{\setcounter{temp}{##1}
    \edef\current@question{\roman{temp}}
    \csname sec\current@section @qst\current@question\endcsname}
  \ifanswer
    \ifcblanks
      \def\blank##1{\mbox{\rule[-1pt]{\blank@length}{.4pt}%
        \hspace{-\blank@length}%
        \makebox[\blank@length]{##1}}}
    \fi
    \ifpblanks
      \def\blank##1{\settowidth{\temp@length}{##1}%
        \mbox{\rule[-1pt]{\blank@multiplier\temp@length}{.4pt}%
        \hspace{-\blank@multiplier\temp@length}%
        \makebox[\blank@multiplier\temp@length]{##1}}}
    \fi
  \else
    \ifcblanks
      \def\blank##1{\rule[-1pt]{\blank@length}{.4pt}}
    \fi
    \ifpblanks
      \def\blank##1{\settowidth{\temp@length}{##1}%
        \rule[-1pt]{\blank@multiplier\temp@length}{.4pt}}
    \fi
  \fi
    \par\medskip
    \ifx\csname head@sec\current@section\endcsname\relax
      \relax
    \else
      \vspace{\beforesectsep}
      \noindent{\csname head@sec\current@section\endcsname}
      \par\vspace{\aftersectsep}
    \fi
    \ifx\csname inst@sec\current@section\endcsname\relax
      \relax
    \else
      \vspace{\beforeinstsep}
      \csname inst@sec\current@section\endcsname
      \par\vspace{\afterinstsep}
    \fi
    \begin{enumerate}
      \the\csname qlist@scr@sec\current@section\endcsname
    \end{enumerate}}
\def\@multiplechoicemain{\setcounter{mcchoice}{1}
   \def\question{\item \begin{minipage}[t]{\linewidth} \@beforequestionhook}
   \def\endquestion{\@endquestionhook \end{minipage}}
   \def\@separator##1{\setcounter{temp}{##1}
     \edef\current@question{\roman{temp}}
     \csname sec\current@section @qst\current@question\endcsname}
   \par\vspace{\beforesectsep}
   \noindent {\large Section \arabic{sectionindex}. \space
   \csname head@sec\current@section\endcsname}
     \par\vspace{\aftersectsep}
   \ifx\csname inst@sec\current@section\endcsname\relax
     \relax
   \else
     \vspace{\beforeinstsep}
     \csname inst@sec\current@section\endcsname
     \par\vspace{\afterinstsep}
   \fi
   \begin{enumerate}
      \the\csname qlist@scr@sec\current@section\endcsname
   \end{enumerate}}
\def\@multiplechoicestarmain{\setcounter{mcchoice}{1}
   \def\question{\item\begin{minipage}[t]{\linewidth}
     \@beforequestionhook}
   \def\endquestion{\@endquestionhook \end{minipage}}
   \def\@separator##1{\setcounter{temp}{##1}
     \edef\current@question{\roman{temp}}
     \csname sec\current@section @qst\current@question\endcsname}
    \ifx\csname head@sec\current@section\endcsname\relax
      \relax
    \else
      \par\vspace{\beforesectsep}
      \noindent{\csname head@sec\current@section\endcsname}
      \par\vspace{\aftersectsep}
    \fi
    \ifx\csname inst@sec\current@section\endcsname\relax
      \relax
    \else
      \vspace{\beforeinstsep}
      \csname inst@sec\current@section\endcsname
      \par\vspace{\afterinstsep}
    \fi
   \begin{enumerate}
      \the\csname qlist@scr@sec\current@section\endcsname
   \end{enumerate}}
\def\@truefalsemain{%
   \def\@separator##1{\setcounter{temp}{##1}
     \edef\current@question{\roman{temp}}
     \csname sec\current@section @qst\current@question\endcsname}
   \def\question{\@tfitem \@beforequestionhook}
   \def\endquestion{\@endquestionhook}
     \ifanswer
       \def\answer##1{\relax}
     \else
       \def\answer##1{\expandafter\gdef
          \csname tf@sol\current@question\endcsname{##1}}
          \vspace{-\smallskipamount}
     \fi
       \par\vspace{\beforesectsep}
       \noindent {\large Section \arabic{sectionindex}. \space
          \csname head@sec\current@section\endcsname}
       \par\vspace{\aftersectsep}
       \ifx\csname inst@sec\current@section\endcsname\relax
         \relax
       \else
         \vspace{\beforeinstsep}
         \csname inst@sec\current@section\endcsname
         \par\vspace{\afterinstsep}
       \fi
     \ifanswer
       \begin{list}{}
          {\setlength{\rightmargin}{0pt}
           \setlength{\labelwidth}{.4in}
           \setlength{\leftmargin}{.5in}
           \setlength{\labelsep}{.1in}
           \setlength{\itemindent}{0in}
           \setlength{\itemsep}{3pt}}
           \the\csname qlist@scr@sec\current@section\endcsname
       \end{list}
     \else
       \begin{list}{$\underline{\mbox{\hphantom{false}}}$}
          {\setlength{\rightmargin}{0pt}
           \setlength{\labelwidth}{.35in}
           \setlength{\leftmargin}{.5in}
           \setlength{\labelsep}{.15in}
           \setlength{\itemindent}{0in}
           \setlength{\itemsep}{3pt}}
           \the\csname qlist@scr@sec\current@section\endcsname
       \end{list}
     \fi}
\def\@truefalsestarmain{%
   \def\@separator##1{\setcounter{temp}{##1}
     \edef\current@question{\roman{temp}}
     \csname sec\current@section @qst\current@question\endcsname}
   \def\question{\@tfitem \@beforequestionhook}
   \def\endquestion{\@endquestionhook}
   \ifanswer
     \def\answer##1{\relax}
   \else
     \def\answer##1{\expandafter\gdef
        \csname tf@sol\current@question\endcsname{##1}}
        \vspace{-\smallskipamount}
   \fi
   \par\medskip
   \ifx\csname head@sec\current@section\endcsname\relax
     \relax
   \else
     \par\vspace{\beforesectsep}
     \noindent{\csname head@sec\current@section\endcsname}
     \par\vspace{\aftersectsep}
   \fi
   \ifx\csname inst@sec\current@section\endcsname\relax
     \relax
   \else
     \vspace{\beforeinstsep}
     \csname inst@sec\current@section\endcsname
     \par\vspace{\afterinstsep}
   \fi
   \ifanswer
     \begin{list}{}
        {\setlength{\rightmargin}{0pt}
         \setlength{\labelwidth}{.4in}
         \setlength{\leftmargin}{.5in}
         \setlength{\labelsep}{.1in}
         \setlength{\itemindent}{0in}
         \setlength{\itemsep}{3pt}}
         \the\csname qlist@scr@sec\current@section\endcsname
     \end{list}
   \else
     \begin{list}{$\underline{\mbox{\hphantom{false}}}$}
        {\setlength{\rightmargin}{0pt}
         \setlength{\labelwidth}{.35in}
         \setlength{\leftmargin}{.5in}
         \setlength{\labelsep}{.15in}
         \setlength{\itemindent}{0in}
         \setlength{\itemsep}{3pt}}
         \the\csname qlist@scr@sec\current@section\endcsname
     \end{list}
   \fi}
\def\@shortanswerstarmain{%
  \def\question{\item \@beforequestionhook}
  \def\endquestion{\@endquestionhook}
  \def\@separator##1{\setcounter{temp}{##1}
    \edef\current@question{\roman{temp}}
    \csname sec\current@section @qst\current@question\endcsname}
  \ifanswer
    \def\answer{\begin{description} \item[Answer:]}
    \def\endanswer{\end{description}}
  \else
    \def\answer{\get@noanswer@body}
    \def\endanswer{\relax}
    \def\@S{answer}
    \long\def\get@noanswer@body##1\end{\find@answer@end}
    \def\find@answer@end##1{\def\@tempa{##1}
      \ifx\@tempa\@S\expandafter\finish@up
        \else\expandafter\get@noanswer@body\fi}
    \def\finish@up{\end{answer}}
  \fi
  \par\medskip
  \ifx\csname head@sec\current@section\endcsname\relax
    \relax
  \else
    \par\vspace{\beforesectsep}
    \noindent{\csname head@sec\current@section\endcsname}
    \par\vspace{\aftersectsep}
  \fi
  \ifx\csname inst@sec\current@section\endcsname\relax
    \relax
  \else
    \vspace{\beforeinstsep}
    \csname inst@sec\current@section\endcsname
    \par\vspace{\afterinstsep}
  \fi
  \begin{enumerate}
    \the\csname qlist@scr@sec\current@section\endcsname
  \end{enumerate}}
\def\@fixedstarmain{%
  \def\question{\item \@beforequestionhook}
  \def\endquestion{\@endquestionhook}
  \def\@separator##1{\setcounter{temp}{##1}
    \edef\current@question{\roman{temp}}
    \csname sec\current@section @qst\current@question\endcsname}
  \ifanswer
     \gdef\answer{\begin{description} \item[Answer:]}
     \gdef\endanswer{\end{description}}
  \else
    \def\answer{\get@noanswer@body}
    \def\endanswer{\relax}
    \def\@S{answer}
    \long\def\get@noanswer@body##1\end{\find@answer@end}
    \def\find@answer@end##1{\def\@tempa{##1}
      \ifx\@tempa\@S\expandafter\finish@up
        \else\expandafter\get@noanswer@body\fi}
    \def\finish@up{\end{answer}}
  \fi
  \par\medskip
  \ifx\csname head@sec\current@section\endcsname\relax
    \relax
  \else
    \par\vspace{\beforesectsep}
    \noindent{\csname head@sec\current@section\endcsname}
    \par\vspace{\aftersectsep}
  \fi
  \ifx\csname inst@sec\current@section\endcsname\relax
    \relax
  \else
    \vspace{\beforeinstsep}
    \csname inst@sec\current@section\endcsname
    \par\vspace{\afterinstsep}
  \fi
  \begin{enumerate}
     \the\csname qlist@scr@sec\current@section\endcsname
  \end{enumerate}
  \global\notfixedtrue}
\def\@endquestionhook{\relax}
\def\@beforequestionhook{\relax}
\def\@tfitem{%
  \ifanswer
    \item[\uline{\mbox{\csname tf@sol\current@question\endcsname}}]
  \else
    \item
  \fi}
\def\@mcitem{\item\begin{minipage}[t]{\linewidth}}
\def\@mcenditem{\end{minipage}}
\def\answerspace#1{\ifanswer \relax \else \vspace*{#1} \fi}
\def\exam#1{\ifanswer\relax\else #1\fi}
\def\key#1{\ifanswer#1\fi}
\def\examvspace{\@ifnextchar*{\@examvspacestar}{\@examvspace}}
\def\@examvspacestar*#1{\exam{\vspace*{#1}}}
\def\@examvspace#1{\exam{\vspace{#1}}}
\def\examhspace{\@ifnextchar*{\@examhspacestar}{\@examhspace}}
\def\@examhspacestar*#1{\exam{\hspace*{#1}}}
\def\@examhspace#1{\exam{\hspace{#1}}}
\def\keyvspace{\@ifnextchar*{\@keyvspacestar}{\@keyvspace}}
\def\@keyvspacestar*#1{\key{\vspace*{#1}}}
\def\@keyvspace#1{\key{\vspace{#1}}}
\def\keyhspace{\@ifnextchar*{\@keyhspacestar}{\@keyhspace}}
\def\@keyhspacestar*#1{\key{\hspace*{#1}}}
\def\@keyhspace#1{\key{\hspace{#1}}}
\endinput
%%
%% End of file `exam.cls'.
